<?php
namespace LMS\Libraries\Config;

defined('_JEXEC') or die;
 
class ConfigLoader
{
    private static $_config;
    private static $config_file = 'config.lms_menu.json';
    private static $config_file_path = '/components/com_joomla_lms/configs/';

    public function __construct($config_file = '')
    {
       if ($config_file)
         {
            if ($config_file!= self::$config_file)
            {
                //echo 'LOAD: '.$config_file; echo '<br/>';
                self::$_config = null;
                self::$config_file = $config_file;
            }

         }
    }

    public static function getConfig($jsonAssoc = true)
    {
        if(is_null(self::$_config))
        {
            self::$_config = new self();
            $json = '{}';

            $config_file_path = JPATH_SITE.self::$config_file_path.self::$config_file;

            if ( file_exists($config_file_path) )
            {
                $json = is_file($config_file_path) ? json_decode(file_get_contents($config_file_path), $jsonAssoc) : NULL;
            }
            self::$_config = $json;
        }
        return self::$_config;
    }

    public static function getConfigParam( $param_name = '' )
    {
        if (!$param_name) return false;
        $result = false;

        $config = self::getConfig();
        $parse_param_name = explode('.',$param_name);
        if (sizeof($parse_param_name))
        {
            if (isset($config[$parse_param_name[0]]))
            {
                $result = $config[$parse_param_name[0]];
            }

            foreach ($parse_param_name as $k=>$part_param_name)
            {
                if ($k==0) continue;
                if ( isset( $result[$part_param_name]) )
                {
                    $result = $result[$part_param_name];
                } else $result = false;
            }
        }
        return $result;
    }
}
?>