<?php
/**
 * User: nester_a
 * Date: 30.10.13
 */

namespace LMS\Libraries\Http;

class Request
{
    /**
     * @param string $url
     * @param array $data
     * @param string $method
     * @param null $optionalHeaders
     * @return bool|string
     */
    public function sendJSONRequest($url, $data=array(), $method = 'POST', $optionalHeaders = null)
    {
        $params = array('http' => array(
            'method' => $method,
            'content' => is_array($data) ? json_encode($data) : $data,
        ));

        if ($optionalHeaders !== null) {
            $params['http']['header'] = implode("\r\n", $optionalHeaders);
        }
        $params['ssl']['verify_peer'] = false;

        $context = stream_context_create($params);
        $fp = fopen( $url, 'rb', false, $context);
        if (!$fp) {
            return false;
        }
        $response = stream_get_contents($fp);

        return $response;
    }

    /**
     * @return array
     */
    public function getHeadersForGTM($token)
    {
        return array(
            "Accept: application/json",
            "Content-type: application/json",
            "Authorization: OAuth oauth_token=".$token
        );

    }

	public function loadXMLSchema($filename, $params=array())
	{
		extract($params);

		ob_start();
		include_once $filename;
		$template = ob_get_contents();
		ob_end_clean();

		return $template;
	}
}