<?php
/**
 * User: nester_a
 * Date: 30.06.14
 */

namespace LMS\Tools\Conference\Service;

use LMS\Libraries\Base;
use LMS\Libraries;

class Date extends Base\Service
{

	/**
	 * @var Libraries\Date\Handler
	 */
	protected $dateHandler;

	private $config;

	public function __construct($options = array())
	{
		parent::__construct($options);
		$this->dateHandler = new Libraries\Date\Handler();
		$this->config = \JLMSFactory::getConfig();
	}

	public function prepareDates($monthYear, $weekDay)
	{
		$month = substr($monthYear,0,2);
		$year = substr($monthYear,3,4);

		$currentDate = $this->dateHandler->getCurrentDatetime("Y-m-d");

		$firstDayFormat = $this->config->get('date_format_fdow') == 1 ? 'N' : 'w';

		$firstDay = $this->dateHandler->getDatetime($firstDayFormat, mktime(0,0,0,$month,1,$year));

		$additional = 1;
		if($this->config->get('date_format_fdow') == 1){
			$additional = 2;
		}

		$dates = array();
		for($i=0; $i<7; $i++){
			if(in_array($i,$weekDay)){
				for($n=0; $n<5; $n++){
					$add_week = ($i<$firstDay) ? ($i-$firstDay+7+$additional) : ($i-$firstDay+$additional);
					$dataz = $this->dateHandler->getDatetime("Y-m-d", mktime(0,0,0,$month,$add_week+7*$n,$year));
					if(substr($dataz,5,2) == $month && strtotime($dataz) >= strtotime($currentDate)){
						$dates[] = $dataz;
					}
				}
			}
		}
		return $dates;
	}
}