jQuery(function( $ ) {
	document.formvalidator.setHandler('price', function(value) {		
		regex=/^\d+\.?\d*$/;
		return regex.test(value);
	});

	function hideFields() {
		$('#jform_start_date').parents('.control-group').hide();
		$('#jform_end_date').parents('.control-group').hide();
		$('#jform_access_days').parents('.control-group').hide();
		$('#jform_discount').parents('.control-group').hide();
		
		$('#jform_start_date').removeAttr('required');
		$('#jform_end_date').removeAttr('required');		
		$('#jform_access_days').removeAttr('required');
		$('#jform_discount').removeAttr('required');
		
		removeStar($('#jform_start_date-lbl'));
		removeStar($('#jform_end_date-lbl'));
		removeStar($('#jform_access_days-lbl'));
		removeStar($('#jform_discount-lbl'));
	}
	
	function addStar(el){						
		el.append($("<span></span>").addClass('star').text('*'));
	}
	
	function removeStar(el){		
		el.find('.star').remove();		
	}
	
	hideFields();
		
	$('#jform_type').on('change', function(){
		var val = $(this).val();
		
		hideFields();
				
		switch (parseInt(val)) {
			case 1:				
			break;
			case 2:
				$('#jform_start_date').parents('.control-group').show();
				$('#jform_end_date').parents('.control-group').show();				
				
				$('#jform_start_date').attr('required', true);
				$('#jform_end_date').attr('required', true);
				
				addStar($('#jform_start_date-lbl'));
				addStar($('#jform_end_date-lbl'));
			break;
			case 3: 
				$('#jform_start_date').parents('.control-group').show();
				$('#jform_start_date').attr('required', true);
				addStar($('#jform_start_date-lbl'));
			break;
			case 4: 
				$('#jform_access_days').parents('.control-group').show();
				$('#jform_access_days').attr('required', true);
				addStar($('#jform_access_days-lbl'));
			break;
			case 5: 
				$('#jform_discount').parents('.control-group').show();
				$('#jform_discount').attr('required', true);
				addStar($('#jform_discount-lbl'));
			break;			
		}
		
	})
});