<?php
defined('JPATH_PLATFORM') or die;

use LMS\Libraries;

class JFormFieldModalSearch extends JFormField
{	
	protected $type = 'Search';
	
	protected function getInput()
	{	
		$hint = $this->translateHint ? \JText::_($this->hint) : $this->hint;
				
		$size         = !empty($this->size) ? ' size="' . $this->size . '"' : '';
		$maxLength    = !empty($this->maxLength) ? ' maxlength="' . $this->maxLength . '"' : '';
		$class        = !empty($this->class) ? ' class="' . $this->class . '"' : '';
		$readonly     = $this->readonly ? ' readonly' : '';
		$disabled     = $this->disabled ? ' disabled' : '';
		$required     = $this->required ? ' required aria-required="true"' : '';
		$hint         = $hint ? ' placeholder="' . $hint . '"' : '';
		$autocomplete = !$this->autocomplete ? ' autocomplete="off"' : ' autocomplete="' . $this->autocomplete . '"';
		$autocomplete = $autocomplete == ' autocomplete="on"' ? '' : $autocomplete;
		$autofocus    = $this->autofocus ? ' autofocus' : '';
		$spellcheck   = $this->spellcheck ? '' : ' spellcheck="false"';
		$pattern      = !empty($this->pattern) ? ' pattern="' . $this->pattern . '"' : '';
		$inputmode    = !empty($this->inputmode) ? ' inputmode="' . $this->inputmode . '"' : '';		
		
		$html = "	
		<div class=\"btn-group pull-left\">
		<input type=\"text\" size=\"40\" class=\"search\" value=\"\" id=\"".$this->id."\" name=\"".$this->name."\" 
			". $class . $size . $disabled . $readonly 
			. $hint . $maxLength . $required . $autocomplete . $autofocus . $spellcheck . $inputmode . $pattern . " />		
		<div class=\"btn-group\">
			<button class=\"btn btn-default search-btn\" title=\"".\JText::_('_JLMS_SEARCH')."\" type=\"button\"><i class=\"icon-search\"></i></button>
			<button class=\"btn btn-default reset-btn\" title=\"".\JText::_('_JLMS_RESET')."\" type=\"button\"><i class=\"icon-remove\"></i></button>
			<button class=\"btn btn-default all-btn\" type=\"button\" data-total=\"".(isset($this->value['total'])?$this->value['total']:'0')."\">".\JText::_('_JLMS_SELECT_ALL')."</button>  
		</div>
		</div>
		";		
		
		return $html;
	}
}
?>