<?php

namespace LMS\Tools\Users\Repositories;

use LMS\Libraries\Base;
use LMS\Tools\Users\Tables;
use LMS\Libraries\Servicelocator;

class StudentGroup extends Base\Repository
{		
	public function __construct($options = array()) 
	{
		parent::__construct($options);
		
		$this->config = ServiceLocator::get('config');
				
		if($this->config->get('use_global_groups')){			
			$this->table = new Tables\UsersInGlobalGroups($this->db);
		} else {
			$this->table = new Tables\UsersInGroups2($this->db);
		}
	}
	
	protected function prepareFilter($query, &$filterOptions)
	{		
		$tableAlias = $this->table->getTableAlias();
		
		if(!$this->config->get('use_global_groups')){
			$query->where($tableAlias.'.course_id = '.$this->config->get('course_id'));
		}		
		
		if(empty($filterOptions['fields'])) {
			$filterOptions['fields'] = $tableAlias.'.*';
		}
				
		if(!empty($filterOptions['group_id'])){
			if(is_array($filterOptions['group_id'])) {
				$strGroups = implode(',', $filterOptions['group_id']);
			} else {
				$strGroups = $filterOptions['group_id'];
			}
			
			$query->where($tableAlias.'.group_id IN ('.$strGroups.')');
		}

		if(!empty($filterOptions['user_id'])){
			if(is_array($filterOptions['user_id'])) {
				$strUsers = implode(',', $filterOptions['user_id']);
			} else {
				$strUsers = $filterOptions['user_id'];
			}
			
			$query->where($tableAlias.'.user_id IN ('.$strUsers.')');
		}
		
		return parent::prepareFilter($query, $filterOptions);
	}
}
?>